#include<bonnet.h>

char *buffer;

int rd_read(int lba,char *buf,int count)
{
	char *ptr;

	if(lba < 0)
		return 0;	

	ptr = buffer + (lba * 512);

	if(buf)
	{
		memcpy(buf,ptr,count * 512);
		return 1;
	}	
	return 0;
}

int rd_write(int lba,char *buf,int count)
{
	int roff;
	char *ptr;

	if(lba < 0)
		return 0;	

	ptr = buffer + (lba * 512);

	if(buf)
	{
		memcpy(ptr,buf,count * 512);	
		return 1;
	}	
	return 0;
}

static struct blkdev_operations rd_ops = {
	rd_read,
	rd_write
};

void init_rd_driver()
{
	buffer = (char *)malloc(1024 * 1024 * 2); // Allocation 1M byte
	register_blkdev(2,&rd_ops,buffer);
}
